import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.DriverManager;

import java.sql.PreparedStatement;
import java.sql.ResultSetMetaData;

public class DBAccess{
	
	protected Connection con;
	protected Statement stmt;
	protected PreparedStatement preStmt;
	protected ResultSet resultSet;
	protected ResultSetMetaData rsMetaData;
	protected final String CONNECTION_STRING = "jdbc:odbc:R_Video";
	protected final String DRIVER = "sun.jdbc.odbc.JdbcOdbcDriver";
	
	protected void connect() throws Exception{
		
		try{
			// JDBChCõ[h
			Class.forName(DRIVER);
			
			// f[^x[Xɐڑ
			con = DriverManager.getConnection(CONNECTION_STRING);
			stmt = con.createStatement();
		}catch(Exception e){
			throw new Exception(e);
		}
	}
	
	protected void close() throws Exception{
		
		try{
			if(stmt != null)
				stmt.close();
			if(con != null)
				con.close();
		}catch(Exception e){
			throw new Exception(e);
		}
	}
	
	protected int getColumnCount(String sql) throws Exception{
		
		int colCnt = -1;
		
		try{
			preStmt = con.prepareStatement(sql);
			rsMetaData = preStmt.getMetaData();
			colCnt = rsMetaData.getColumnCount();
		}catch(Exception e){
			e.printStackTrace();
			throw new Exception(e);
		}
		
		return colCnt;
	}
	
	protected String getColumnName(String sql, int colNum) throws Exception{
		
		String colName;
		
		try{
			preStmt = con.prepareStatement(sql);
			rsMetaData = preStmt.getMetaData();
			colName = rsMetaData.getColumnName(colNum);
		}catch(Exception e){
			e.printStackTrace();
			throw new Exception(e);
		}
		
		return colName;
	}
	
	protected ResultSet select(String sql) throws NotFoundException {
		
		try{
			// f[^̊Jn
			resultSet = stmt.executeQuery(sql);
		}catch(Exception e){
			e.printStackTrace();
			throw new NotFoundException(e.getMessage());
		}
		
		return resultSet;
	}
	
	protected int insert(String sql) throws Exception{
		
		int insertCnt;
		
		try{
			// f[^̍폜
			insertCnt = stmt.executeUpdate(sql);
		}catch(Exception e){
			e.printStackTrace();
			throw new Exception(e);
		}
		
		return insertCnt;
	}
}
	